//  RungeKutta4.h

#ifndef __include_rungekutta4_h__
#define __include_rungekutta4_h__


#include <vector>
using std::vector;

typedef void (*RHSFunc)(double tt, vector<double> y, vector<double>& dy);


class RungeKutta4 {
public:
    RungeKutta4(int n, double dt);
    void advanceStep(RHSFunc rhs, double t, vector<double>& y);
private:
    int n;
    double h;
    vector<double> yn;
    vector<double> k1;
    vector<double> k2;
    vector<double> k3;
    vector<double> k4;
};
#endif
