//  RungeKutta4.
#ifndef __include_rungekutta4_h__
#define __include_rungekutta4_h__

#include <vector>

using std::vector;

class RungeKutta4{
public:
    void initRK4(int n, double dt);
    void advanceStep(double t, vector<double>& y);
    virtual void rhs(double tt, vector<double> y, vector<double>& dy){};
private:
    int n;
    double h;
    vector<double> yn;
    vector<double> k1;
    vector<double> k2;
    vector<double> k3;
    vector<double> k4;
};
#endif
