//  main.cpp of ode (ex07b)
#include <iostream>
#include <fstream>
#include <string>
#include "Eqs.h"

int main(int argc, char** argv){
    int ndim = 2;                 // number of equations
    double ttime = 100.0;         // total time
    double dt = 0.1;              // step size
    int npts = (int)(ttime/dt)+1;
    vector<double>  y={1.0, 0.0};
    double a = 1.0;               // default parameter
    double b = 0.1;               // default parameter
    if(argc >= 3){
        a = std::stof(std::string(argv[1]));
        b = std::stof(std::string(argv[2]));
        if(argc == 5){
            y[0] = std::stof(std::string(argv[3]));
            y[1] = std::stof(std::string(argv[4]));
        }
    }
    Eqs ce;
    ce.setParams(a,b);
    ce.initRK4(ndim, dt);

    std::fstream fd("ax.txt", std::ios::out | std::ios::trunc);
    for(int i=0;i<npts;i++){
        double t = dt*i;
        fd << t << " " << y[0] << " " << y[1] << std::endl;
        ce.advanceStep(t, y);
    }
    fd.close();
#if defined(_WIN32)
    system("..\\..\\tools\\gc ax.txt ");
#else
    system("../../tools/gc ax.txt ");
#endif
    return 0;
}
