// main.cpp of channel
#include <iostream>
#include <fstream>
#include <cmath>
#include "Markov.h"

int main(){
    const int ndim = NUM_OF_NA_STATES;
    const double dt = 0.01;
    const double totalTime = 50.0;
    const int npts = (int)(totalTime/dt)+1;

    std::vector<double> y(ndim);
    
    Markov ce;
    ce.initRK4(ndim, dt);    
    ce.setInitialValues(y);

    std::fstream fd("ax.txt", std::ios::out | std::ios::trunc);
    for(int i=0; i<npts; i++){
        double t = dt*i;
        fd << t << " " << y[0] << " " << y[3]<< " " << y[6]<< " "
		   << y[7] << " " << y[8]<<std::endl;
        ce.advanceStep(t, y);
    }
    fd.close();
#if defined(_WIN32)
    system("..\\..\\tools\\gc ax.txt &");
#else
    system("../../tools/gc ax.txt &");
#endif
    return 0;
}
