//  ode.java (ex07)
import java.io.FileWriter;
import java.io.IOException;

public class ode{

    public static void main(String [] args){

        int n = 2;                 // number of equations
        double h = 0.1;              // step size
        double ttime = 10.0;          // total time
        int npts = (int)(ttime/h)+1; // number of points
        double [] y = {1.0, 0.0};  // initial values
        
        Eqs eq = new Eqs();
        eq.initRK4(n, h);

        try{
            FileWriter fw = new FileWriter("ax.txt");
            for(int i=0;i<npts;i++){
                double t = h*i;
                fw.write(t + " " + y[0] + " " + y[1] + "\n");
                eq.advanceStep(t, y);
            }
            fw.close();
        }catch(IOException e){
            System.out.println(e);
        }

        String cmd;
        String OS = System.getProperty("os.name", "generic").toLowerCase();
        if (OS.indexOf("win") >= 0) {
            cmd = "cmd /c ..\\..\\tools\\gc ax.txt";            
        }else{ // mac
            cmd = "..//..//tools//gc ax.txt";
        }
        
        try{
            Process p = Runtime.getRuntime().exec(cmd);
            p.waitFor();
        } catch (Exception e) {}
    }
}
