public class Eqs extends RungeKutta4 {

    double a11, a12, a13, a2, a3, a4, a5;
    double b11, b12, b13, b2, b3, b4, b5;
    double vold;

    public Eqs(){
        vold = -1000.0;
    }

    public void rhs(double t, double [] y, double [] dy){
        double v = t<20.0 || t>= 30.0 ? -100.0 : 0.0;
        if(v != vold){
            a11 = 3.802/(0.1027*Math.exp(-v/17.0) + 0.20*Math.exp(-v/150));
            a12 = 3.802/(0.1027*Math.exp(-v/15.0) + 0.23*Math.exp(-v/150));
            a13 = 3.802/(0.1027*Math.exp(-v/12.0) + 0.25*Math.exp(-v/150));

            b11 = 0.1917*Math.exp(-v/20.3);
            b12 = 0.20*Math.exp(-(v-5)/20.3);
            b13 = 0.22*Math.exp(-(v-10)/20.3);

            a3 = (3.7933e-7)*Math.exp(-v/7.7);
            b3 = 0.0084 + 0.00002*v;

            a2 = 9.178*Math.exp(v/29.68);
            b2 = (a13*a2*a3)/(b13*b3);

            a4 = a2/100;
            b4 = a3;

            a5 = a2/(9.5e4);
            b5 = a3/50;
            vold = v;
        }
        dy[0] = -(a11 + b3)*y[0] + b11*y[1] + a3*y[4];
        dy[1] = -(b11 + b3 + a12)*y[1] + a11*y[0] + b12*y[2] + a3*y[5];
        dy[2] = -(b12 + b3 + a13)*y[2] + a12*y[1] + b13*y[3] + a3*y[6];
        dy[3] = -(b13 + a2)*y[3] + a13*y[2] + b2*y[6];
        dy[4] = -(a11 + a3)*y[4] + b11*y[5] + b3*y[0];
        dy[5] = -(b11 + a3 + a12)*y[5] + a11*y[4] + b12*y[6] + b3*y[1];
        dy[6] = -(b12 + a3 + b2 + a4)*y[6] + a12*y[5] + b3*y[2] + a2*y[3] + b4*y[7];
        dy[7] = -(b4 + a5)*y[7] + a4*y[6] + b5*y[8];
        dy[8] = -b5*y[8] + a5*y[7];
    }
}
